
#include "helpers.h"
#include <includes.h>

int timeoutread(int timeout,int fd,char *buf,int len)
{
  fd_set rfds;
  struct timeval tv;

  tv.tv_sec = timeout;
  tv.tv_usec = 0;

  FD_ZERO(&rfds);
  FD_SET(fd,&rfds);

  if (select(fd + 1,&rfds,(fd_set *) 0,(fd_set *) 0,&tv) == -1) 
      return -1;
      
  if (FD_ISSET(fd,&rfds)) 
      return read(fd,buf,len);

  errno = ETIMEDOUT;
  return -1;
}

int timeoutwrite(int timeout , int fd, char *buf, int len)
{
  fd_set wfds;
  struct timeval tv;

  tv.tv_sec = timeout;
  tv.tv_usec = 0;

  FD_ZERO(&wfds);
  FD_SET(fd,&wfds);

  if (select(fd + 1,(fd_set *) 0,&wfds,(fd_set *) 0,&tv) == -1) 
      return -1;
      
  if (FD_ISSET(fd,&wfds)) 
      return write(fd,buf,len);

  errno = ETIMEDOUT;
  return -1;
}

#define INT_BUF_LEN	512

static char int_buffer[INT_BUF_LEN];
static int int_buf_len = 0;
static int int_buf_pos = 1;

int get_timeout_ch(int fd, int timeout, char *ch)
{
    if (int_buf_pos > int_buf_len)
    {
	if ((int_buf_len = timeoutread(timeout, fd,int_buffer, INT_BUF_LEN)) <= 0 ) return -1;
	int_buf_pos = 0;
    }
    
    *ch = int_buffer[int_buf_pos];
    int_buf_pos++;
    
    return 1;
}

int out(int socket, int timeout, char *str)
{
    return timeoutwrite(timeout, socket, str, strlen(str));
}

