#ifndef __VSCAN_KAVP_H_
#define __VSCAN_KAVP_H_

#include <includes.h>


#ifdef HAVE_UTIME_H
#include <utime.h>
#endif

#ifdef HAVE_DIRENT_H
#include <dirent.h>
#endif

#ifdef HAVE_FCNTL_H
#include <fcntl.h>
#endif

/* Configuration Section :-) */

/* which samba version is this VFS module compiled for:
 * Set SAMBA_VERSION_MAJOR to 3 for Samba 3.0 alpha0 or
 * to 2 for Samba 2.2.x
 * Set SAMBA_VERSION_MINOR to 2 if you're using Samba 2.2.2 or
 * to 1 if you're using Samba 2.2.0[a] or 0 for Samba 2.2.0[a]
 * If SAMBA_VERSION_MAJOR is set to 3, SAMBA_VERSION_MINOR
 * is ignored!
*/


#ifndef SAMBA_VERSION_MAJOR
# define SAMBA_VERSION_MAJOR 2
#endif

#ifndef SAMBA_VERSION_MINOR
# define SAMBA_VERSION_MINOR 2
#endif 


/* 0 = log only infected file, 1 = log every file access */

#ifndef VSCAN_KAVP_VERBOSE_FILE_LOGGING
# define VSCAN_KAVP_VERBOSE_FILE_LOGGING 0
#endif

/* if a file is bigger than VSCAN_KAVP_MAX_SIZE it won't be scanned. Has to be
   specified in bytes! If it set to 0, the file size check is disabled */

#ifndef VSCAN_KAVP_MAX_SIZE
# define VSCAN_KAVP_MAX_SIZE 0
#endif

/* End Configuration Section */

#ifndef SYSLOG_FACILITY
#define SYSLOG_FACILITY   LOG_USER
#endif

#ifndef SYSLOG_PRIORITY
#define SYSLOG_PRIORITY   LOG_NOTICE
#endif



#ifndef bool 
 #ifndef BOOL_DEFINED
  typedef int bool;
 #endif
#endif 

#ifndef FALSE
# define FALSE  0
#endif /* ! FALSE */
#ifndef TRUE
# define TRUE   1
#endif /* ! TRUE */

/* Globals */
int 	kavp_socket;			/* Rember our socket number  -1 is not socket */

int  vscan_kavp_scanfile(char *scan_file);
void vscan_kavp_init(void);
void vscan_kavp_end(void);


#endif /* __VSCAN_KAVP_H */

