#ifndef __VSCAN_SYMANTEC_H_
#define __VSCAN_SYMANTEC_H_

#include "config.h"

#include <sys/types.h>

#ifdef TIME_WITH_SYS_TIME
 #include <sys/time.h>
 #include <time.h>
#else
 #ifdef HAVE_SYS_TIME_H
  #include <sys/time.h>
 #else
  #include <time.h>
 #endif
#endif


#ifdef HAVE_UTIME_H
 #include <utime.h>
#endif

#ifdef HAVE_DIRENT_H
 #include <dirent.h>
#endif

#ifdef HAVE_FCNTL_H
 #include <fcntl.h>
#else
 #ifdef HAVE_SYS_FCNTL_H
  #include <sys/fcntl.h>
 #endif
#endif

#include <stdio.h>

#ifdef HAVE_STDLIB_H
 #include <stdlib.h>
#endif

#include <syslog.h>

#ifdef HAVE_STDARG_H
 #include <stdarg.h>
#else
 #include <varargs.h>
#endif


#ifdef HAVE_UNISTD_H
 #include <unistd.h>
#endif

#ifdef HAVE_STRING_H
 #include <string.h>
#endif

#ifdef HAVE_STRINGS_H
 #include <strings.h>
#endif


#include <errno.h>
#include <pwd.h>
#include <sys/stat.h>



/* Configuration Section :-) */

/* which samba version is this VFS module compiled for:
 * Set SAMBA_VERSION_MAJOR to 3 for Samba 3.0 alpha0 or
 * to 2 for Samba 2.2.x
 * Set SAMBA_VERSION_MINOR to 2 if you're using Samba 2.2.2 or
 * to 1 if you're using Samba 2.2.0[a] or 0 for Samba 2.2.0[a] 
 * If SAMBA_VERSION_MAJOR is set to 3, SAMBA_VERSION_MINOR
 * is ignored!
*/

#ifndef SAMBA_VERSION_MAJOR
# define SAMBA_VERSION_MAJOR 2 
#endif

#ifndef SAMBA_VERSION_MINOR
# define SAMBA_VERSION_MINOR 2
#endif 

/* 0 = log only infected file, 1 = log every file access */

#ifndef VSCAN_SYMANTEC_VERBOSE_FILE_LOGGING
# define VSCAN_SYMANTEC_VERBOSE_FILE_LOGGING 0   
#endif

/* if a file is bigger than VSCAN_SYMANTEC_MAX_SIZE it won't be scanned. Has to be
   specified in bytes! If it set to 0, the file size check is disabled */

#ifndef VSCAN_SYMANTEC_MAX_SIZE 
# define VSCAN_SYMANTEC_MAX_SIZE 0 
#endif

/* IP and port CarrierScan listens on */
static const char CS_IP_PORT[] = "127.0.0.1:7777";


/* End Configuration Section */


#ifndef SYSLOG_FACILITY
#define SYSLOG_FACILITY   LOG_USER
#endif

#ifndef SYSLOG_PRIORITY
#define SYSLOG_PRIORITY   LOG_NOTICE
#endif

#ifndef bool 
 #ifndef BOOL_DEFINED
   typedef int bool;
 #endif
#endif 

#ifndef FALSE
# define FALSE	0
#endif /* ! FALSE */
#ifndef TRUE
# define TRUE	1
#endif /* ! TRUE */



/* functions by vscan-symantec_core */
/* initialize CarrierScan API */
void vscan_symantec_init(void); 
/* print a message via syslog */
void vscan_symantec_print(char *printMessage, ...);
/* scans a file */
int vscan_symantec_scanfile(char *scan_file);
/* terminates CarrierScan API */
void vscan_symantec_end(void);


#endif /* __VSCAN_SYMANTEC_H_ */
