/*
 * $Id: vscan-trend_core.c,v 1.2 2001/11/18 14:23:22 reniar Exp $
 *
 * Core Interface for Trend VSAPI
 *
 * Copyright (C) Rainer Link, SuSE GmbH <link@suse.de>, 2001
 *                            OpenAntiVirus.org <rainer@openantivirus.org>
 *
 * This stuff is heavily based on Trophie by
 * Copyright (C) Vanja Hrustic, 2001
 *
 * This software is licensed under the GNU General Public License (GPL)
 * See: http://www.gnu.org/copyleft/gpl.html
 *
*/



#include "vscan-trend.h"

extern bool vsapi_ok;

void vscan_trend_print(char *printMessage, ...)
{
        char printMsg[512];

        va_list argptr;
        va_start(argptr, printMessage);
        vsnprintf(printMsg, sizeof(printMsg)-1, printMessage, argptr);
        va_end(argptr);

        syslog(SYSLOG_PRIORITY, "%s", printMsg);
}



/* Scan a file */
int vscan_trend_scanfile(char *scan_file)
{
	vs_ret = VSVirusScanFileWithoutFNFilter(vs_addr, scan_file, -1);
	
	/* Lame. Hopefully just a temporary thing */
	/* Returned for .bz2 archives, and some MPEG files - not sure why it's -89, but we're not missing viruses */
	if (vs_ret == -89)
		vs_ret = 0;
	
	return vs_ret;
}

/* This is not used */
int pre_extract_arch_func_callback(char *a)
{
	/* still to figure out this one - I don't actually need it */
	return(0);
}

/* int callback_fn(char *a, char *b, int c, char *d) */
int vs_virus_scan_file_callback_function(char *a, struct callback_type *b, int c, char *d)
{
	char full_path_filename[1024];

	/* Only c == 1 needs to be processed = no idea what for 2nd run is used for (and don't want to know) */
	if (c == 1)
		#if VSCAN_TREND_VERBOSE_FILE_LOGGING==1 
		vscan_trend_print("scanning file: '%s'", b->current_filename);
		#endif

	if ( (c == 1) && (b->flag_infected > 0) )
	{
		char *virus_name = (char *)(b->vname+8);

		strncpy(VIR_NAME, virus_name, sizeof(VIR_NAME)-1);
		memset(full_path_filename, 0, sizeof(full_path_filename));
	
		if (b->flag_archive == 1)
		{
			char *infected_file = (char *)(b->current_filename);
			VSMergeDir(full_path_filename, working_dir, b->archive_being_scanned);
			vscan_trend_print("Scan result: Archive '%s' contains file (%s) infected with '%s' virus - Access denied", full_path_filename, infected_file, virus_name);
		}
		else
		{
			VSMergeDir(full_path_filename, working_dir, b->current_filename);
			vscan_trend_print("Scan result: File '%s' infected with '%s' virus - Access denied", full_path_filename, virus_name);
		}
	}
        #if VSCAN_TREND_VERBOSE_FILE_LOGGING==1
	else if ( (c == 1) && (!b->flag_infected > 0) ) {
		memset(full_path_filename, 0, sizeof(full_path_filename));
	
		if (b->flag_archive == 1)
		{
			//char *infected_file = (char *)(b->current_filename);
			VSMergeDir(full_path_filename, working_dir, b->archive_being_scanned);
			vscan_trend_print("Scan result: Archive '%s' is clean", full_path_filename);
		}
		else
		{
			VSMergeDir(full_path_filename, working_dir, b->current_filename);
			vscan_trend_print("Scan result: File '%s' is clean", full_path_filename);
		}
	}
	#endif

	return(0);
}

