/*
 * $Id: vscan-trend_init.c,v 1.3 2001/11/18 14:23:22 reniar Exp $
 *
 * Core Interface for Trend VSAPI
 *
 * Copyright (C) Rainer Link, SuSE GmbH <link@suse.de>, 2001
 *                            OpenAntiVirus.org <rainer@openantivirus.org>
 *
 * This stuff is heavily based on Trophie by
 * Copyright (C) Vanja Hrustic, 2001
 *
 * This software is licensed under the GNU General Public License (GPL)
 * See: http://www.gnu.org/copyleft/gpl.html
 *
*/



#include "vscan-trend.h"
#include "vscan-trend_init.h"

bool vsapi_ok = TRUE;

/* Initialize VSAPI */
void vscan_trend_init(void)
{
        if((vs_ret = VSInit(getpid(), "VSCAN", -1, &vs_addr)) != 0)
        {
                vscan_trend_print("ERROR: VSInit() failed (return code: [%d])\n", vs_ret);
               vsapi_ok = FALSE; 
        } else {
        	/* Should work... ;) */
        	if ((vs_ret = VSReadVirusPattern(vs_addr, -1, 0, 0)) != 0)
        	{
                	vscan_trend_print("VSReadVirusPattern() failed (return code: [%d])\n", vs_ret);
                	vsapi_ok = FALSE;
        	} else {

        		trophie_vs.handle_addr = vs_addr;
        		trophie_vs.version_string[0] = 0;

        		if ((vs_ret = VSGetVSCInfo(&trophie_vs)) != 0)
        		{
                		vscan_trend_print("VSGetVSCInfo() failed (return code: [%d])\n", vs_ret);
                		vsapi_ok = FALSE;
        		} else {

        			/* Set the callback function */
        			if ((vs_ret = VSSetProcessFileCallBackFunc(vs_addr, &vs_virus_scan_file_callback_function)) != 0)
        			{
                			vscan_trend_print("VSSetProcessFileCallBackFunc() failed (return code: [%d]\n", vs_ret);
               				vsapi_ok = FALSE;
        			} else {

        			/* Here we will set some params on our own */
        			/* To define them, look at trophie_init.h file */
        				if (VS_PROCESS_ALL_FILES_IN_ARCHIVE)
                				VSSetProcessAllFileInArcFlag(vs_addr, 1);
        
       					 if (VS_PROCESS_ALL_FILES)
                				VSSetProcessAllFileFlag(vs_addr, 1);
				}
			}
		}
	}
}

/* Bye, bye, VSAPI */
void vscan_trend_end(void)
{
        if ((vs_ret = VSQuit(vs_addr)) != 0)
        {
                vscan_trend_print("ERROR: VSQuit() failed (return code: [%d])\n", vs_ret);
        } else {

        	vscan_trend_print("Cleanup: VSAPI cleaned up and terminated");
	}
}
