#ifndef __VSCAN_TREND_VSAPI_H_
#define __VSCAN_TREND_VSAPI_H_


/* For VSInit() */
struct trophie_vs_type {
	int handle_addr;
	int vs_pid; /* PID - getpid() result, which we've given to it */
	char vscan_str[9]; /* holds 'VSCAN___' */
	char version_string[11]; /* version string */
	unsigned short pattern_version; /* pattern version */
	unsigned short unknown_1; /* don't care, and don't want to care */
	unsigned long pattern_number; /* pettern number (how many viruses it detects - I think :) */
};

/* For callbackup function */
struct callback_type {
	int flag_infected; /* set to 1 if file is infected */
	int flag_archive; /* is the file to be checked actually an archive? */
	int so_far_it_was_always_minus_one; /* no idea yet for what this is used */
	char *archive_being_scanned; /* The name of the *archive* (filename) being scanned - will be NULL if we're scanning file (not archive) */
	char this_is_how_windows_source_code_looks_like[156]; /* this is definitelly not right, but we don't really care for data inside :) */
	char *vname; /* This is what we care about - virus name :) */
	char *current_filename; /* Filename being checked  */
};

/* mostly used for trophie_show_settings() */
int VSGetLogFlag(int);
int VSGetScanJavaFlag(int);
int VSGetScanMacroFlag(int);
int VSGetSoftMiceFlag(int);
int VSGetExtractArchiveFlag(int);
int VSGetExpandLiteFlag(int);
int VSGetDecodeFlag(int);
int VSGetSmartDecompressFlag(int);
int VSGetHeuristicLevel(int, int *);
int VSGetVSVerboseLevel(int, int *);
int VSGetDecompressLayer(int);
int VSGetConfChangeFlag(int);
int VSGetCurrentPatternFileVersion(int, int *);
int VSGetVSDebug(int);
int VSGetExtractAmgFlag(int);
int VSGetScanLiteFileFlag(int);
int VSGetProcessAllFileInArcFlag(int);
int VSGetKeepDecompressFileFlag(int);
int VSGetEncryptTempFileFlag(int);
int VSGetProcessAllVolumeFlag(int);
int VSGetScanBPFlag(int);
int VSGetScanMemoryFlag(int);
int VSGetProcessAllSubDirFlag(int);
int VSGetProcessAllFileFlag(int);
int VSGetCountFileFlag(int);
int VSGetScanGenericMacroFlag(int);
int VSGetExtractPath(int, char *, int);
int VSGetTempPath(int, char *, int);
int VSGetLogFilePath(int, char *, int);
int VSGetVirusHospitalPath(int, char *, int);
int VSGetPatternPath(int, char *, int);
int VSGetDetectableVirusNumber(int);
int VSGetOleEmbedScanLayer(int);
int VSGetRTFScanLayer(int);
int VSGetMsgScanLayer(int);
int VSGetScriptTrapFlag(int);
int VSGetRedAlertFlag(int);
int VSGetMemoryDecompressSize(int, int *);
int VSGetExtractFileSizeLimit(int, int *);
int VSGetExtractFileSizeLimit(int, int *);
int VSGetDefaultExtListSize(int, int *);
int VSGetDefaultExtList(int, char *);

/* trophie_init() */
int VSInit(pid_t, char *, int, int *);
int VSReadVirusPattern(int, int, int, int);
int VSGetVSCInfo(struct trophie_vs_type *);
/* int VSSetProcessFileCallBackFunc(int, XXX); */
int (VSSetProcessFileCallBackFunc)();
int VSSetProcessAllFileInArcFlag(int, int);
int VSSetProcessAllFileFlag(int, int);
int VSQuit(int);

/* trophie_scandir() */
/* int VSScanDir(int, char *, XXX, XXX , int *); */
int (VSScanDir)();

/* trophie_scanfile */
int VSVirusScanFileWithoutFNFilter(int, char *, int);

/* vs_virus_scan_file_callback_function() */
int VSMergeDir(char *, char *, char *);

#endif /* __VSCAN_TREND_VSAPI_H_ */
